{"openapi":"3.0.3","info":{"title":"Customers 1st API","description":"# General\n\n## Help and support\n\nIf you have any questions regarding the API we are happy to help you via our API support at <api@c1st.com>.\n\nPlease be specific and include the following information:\n\n * A detailed description of the problem with a step-by-step description of what you do and what happens.\n * Store details, specifically the StoreId.\n * If possible, include a complete request and response.\n * Screenshots, if possible.\n * Other relevant or helpful information.\n\n## Usage\n\nThe API is forward-compatible. We take the freedom to add **optional** attributes to endpoints without notice. In this case, you should be aware that a PUT request replaces an entire object. i.e. not specifying a field on an object will **null** the field. To update a single field on e.g. a product you must first GET the product and then PUT the entire product with the new updated field. See example below.\n\nWe may introduce breaking changes to endpoints. In such case, you will be contacted via the email provided at the API token setup page with a transition period. \n\n## Authentication\n\nSend the header\n\n`Authorization: Bearer <token>`\n\n`<token>` can be found at [https://app.c1st.com/en](https://app.c1st.com/en) -> Settings -> API -> API users.\n\nWe recommend creating a new user for each integration.\n\n## Rate limiting\n\nAPI requests are subject to potential throttling to limit excess load on our servers.\n\nThrottling of requests is based on a _simple bucket resource model_ (similar to the leaking bucket algorithm, except the bucket fills up instead of leaking). You are free to make API requests until the resource bucket is depleted, after which requests will return an HTTP 429 error.\n\nThe current bucket size is 80 and the filling (regen) rate is 8 requests per second. These limitations are subject change but are included within the HTTP response for throttled requests:\n\n```json\n{\n    \"error\": \"API Resource limit reached.\",\n    \"bucket_size:\" \"80\",\n    \"bucket_regen\": \"8\"\n}\n```\n## Fair usage\n\nWe ask that you use the API fairly and avoid introducing unnecessary load. Continuously retrieving all data, or routinely updating the entire product catalog through bulk operations, are examples of what we consider unfair API usage. Instead, use hooks and update only the products that have changed.\n\nCustomers 1st monitors API usage to identify excessive consumption. We will make every effort to contact you before taking action, but we may be required to reduce your limits until the matter has been resolved.\n\nIntegrators who misuse the API will be warned and asked to take the necessary steps to comply with fair usage. We will reach out using the API user contact email configured under **Settings → API**. If an integrator does not respond or comply within the given timeframe, Customers 1st administrators may suspend the relevant services or the API user in order to prevent further misuse.\n\n\n## Configs\n\nA list of settings configs can be found [here](https://api.c1st.com/doc/api/configs.php)\n\n\n# Examples\n## Common Requests\n\n### Fetch updated ressources since given timestamp\nA common operation you might want to do is fetch all the products from Customers 1st that where changed since the last time you \"checked\". The way to do this is to use the `updated_after` query parameter on the products search [endpoint](https://api-docs.c1st.com/#tag/Products/operation/searchProduct). So lets say for example today's date is the 20. of December and you want every product that was changed since the 19. of December. You would make a request like so:\n\n```bash\ncurl \\\n  -H 'Content-Type: application/json' \\\n  https://api.c1st.com/api/products?updated_after=2023-12-19 00:00:00\n```\n\nThis would then return a list of products updated after that date. If the amount of products changed are greater than 50 you would still have to paginate through the list. Use the `cursor` query parameter as described in [Pagination](#section/Pagination).\n\n#### Stock changes\nTo achive the same for stocktransaction, the request is almost the same as the example above. Here you use the search stockstransactions [endpoint](https://api-docs.c1st.com/#tag/StockTransactions/operation/getStockTransactions) with the query paramenter `committed_after`. So to get all stock transactions after the 19. of December 2023 you would make a request like so:\n\n```bash\ncurl \\\n  -H 'Content-Type: application/json' \\\n  https://api.c1st.com/api/stocktransactions?committed_after=2023-12-19 00:00:00\n```\n\n\n# Pagination\n\n## Cursor-based pagination (recommended)\n\nEndpoints that have been migrated to cursor-based pagination accept a `cursor` query parameter. **Use cursor-based pagination whenever an endpoint supports it.** It stays fast regardless of how deep you page, and you will not skip or receive duplicate items when data is created or deleted while you are paging.\n\nCheck the documentation of each endpoint to see whether it supports the `cursor` parameter, and which response field holds the next cursor.\n\nTo page through the results:\n\n1. Make the first request with an empty `cursor` parameter, e.g. `?cursor=&paginationPageLength=250`.\n2. Read the next cursor from the response (see the endpoint's documentation for the field name) and pass it unchanged as `cursor` in the next request. Keep all other query parameters the same.\n3. Repeat until the next cursor is `null`.\n\n```bash\ncurl \\\n  -H 'Content-Type: application/json' \\\n  'https://api.c1st.com/api/products?cursor=&paginationPageLength=250'\n\ncurl \\\n  -H 'Content-Type: application/json' \\\n  'https://api.c1st.com/api/products?cursor=eyJQcm9kdWN0LmlkIjoxMjM0LCJfcG9pbnRzVG9OZXh0SXRlbXMiOnRydWV9&paginationPageLength=250'\n```\n\nTreat the cursor as an opaque string: do not decode, modify or build it yourself. When `cursor` is set, `paginationStart` is ignored, and cursor-based pagination is only allowed with the default sorting or sorting by id.\n\n## Offset-based pagination (legacy)\n\nEndpoints that have not yet been migrated to cursor-based pagination use the GET parameters `paginationStart` and `paginationPageLength`. The pagination is based on element count.\nFor example, if you want to access the third page of a pagination with 10 items per page use:\n\n`?paginationStart=20&paginationPageLength=10`\n\nSome endpoints support both methods for backwards compatibility. On those endpoints we recommend switching to cursor-based pagination.\n\nFor all endpoints `paginationPageLength` is limited to **250**. We are currently working on implementing this limit.\n\n# Hooks\n\nThe Customers 1st API supports REST Hooks. This allows you to subscribe to events in our system and get notified via a callback url immediately.\n\nTo listen for events,\n\n`POST /api/hooks`\nwith JSON object\n\n```json\n{\n    \"event\": \"<event>\",\n    \"url\": \"<url>\"\n}\n```\n\nThis call returns a unique id for that subscription that is needed to manage the subscription.\n\nWhen the event triggers in our system, we will POST to the specified `url` with a relevant payload, for instance the product that was created in case of `product.created`.\n\nEvents can be:\n\n```js\nnotification.created\ninventorycount.created\ninventorycount.updated\ninventorycount.deleted\nproduct.created\nproduct.updated\nproduct.deleted\nproductdata.updated\ninventorylevel.updated\ninventorylevel.created\nsupplier.updated\nsupplier.deleted\nsupplier.created\npospayment.created\nposbalance.created\ncustomer.created\ncustomer.updated\ncustomer.deleted\nshoppinglistorder.created\nshoppinglistorder.committed\nshoppinglistorder.deleted\nshoppinglistitem.created\nshoppinglistitem.updated\nshoppinglistitem.deleted\ncustomertags.created\ncustomertags.updated\ncustomertags.deleted\ncustomerarticle.created\ncustomerarticle.updated\ncustomerarticle.deleted\ntaskmaterial.created\ntaskmaterial.updated\ntaskmaterial.deleted\ntask.created\ntask.updated\ntask.deleted\ntaskcomment.created\ntaskcomment.updated\ntaskcomment.deleted\nservicesubscription.created\nservicesubscription.deleted\nstocktransaction.committed\nstocktransactionlist.created\nstocktransactionlist.updated\nstocktransactionlist.committed\nstocktransactionlist.deleted\ngiftcard.created\ngiftcard.updated\ngiftcard.deleted\nloyaltybalance.updated\nsalesorder.created\nsalesorder.updated\nsalesorderfulfillment.created\nsalesorderfulfillment.updated\npayout.created\npayout.updated\npayout.booked\npromotion.created\npromotion.updated\npromotion.deleted\nverifiedsupplier.store.connected\nverifiedsupplier.store.disconnected\nverifiedsupplier.orderlist.created\n```\n\nTo unsubscribe\n`DELETE /api/hooks/{id}`\nYou can also unsubscribe by returning status code 410 (Gone) when your callback url is notified.\n\nREST hooks can also be specified via the app under Settings -> API.\n\nIf the request returns **408** (Request Timeout), **429** (Too Many Requests) or **5xx** (Server Error) the server will **retry a maximum of 3 times, with an increasing interval of 30, 60, and finally 120 minutes**, after which the hook will be considered failed.\n\n## Suppress Hooks\n\nWhen using the API to make changes to your store, for instance create products, these interactions will trigger events like `product.created` just like using the app would.\n\nIn some cases this behaviour is not desired since it can create infinite loops between services, for instance stock sync between Customers 1st and e-conomic.\n\nTo avoid this, interact with the API with the following header\n`X-Suppress-Hooks:`\nThe content of the header doesn't matter and is ignored.\n\n## Validate Hooks\n\nAll resthooks from Customers 1st are signed using a store's signing secret. The signature is set in a header called `X-C1st-Webhook-Signature`. The secret can be changed under api settings or set using the api by changing the store config `resthook_signing_secret`\n\nTo validate a resthook, you need to calculate the HMAC of the request payload using the signing secret.\n\nHere is an example in Laravel/PHP\n\n```php\n    public function validateResthook(\\Illuminate\\Http\\Request $request)\n    {\n        $signature = $request->header('X-C1st-Webhook-Signature');\n\n        $secret = \"resthook_super_secret_1337\";\n\n        $payload = $request->getContent();\n        $calculated_hmac = base64_encode(hash_hmac('sha256', $payload, $secret, true));\n\n        if ($signature != $calculated_hmac) {\n            abort(401, 'Webhook failed signature check');\n        }\n    }\n```\n","contact":{"name":"info@c1st.com"},"version":"1.0.0"},"tags":[{"name":"Billing","x-displayName":"Billing"},{"name":"Bundle - Experimental","x-displayName":"Bundle - Experimental"},{"name":"BundleFilter - Experimental","x-displayName":"BundleFilter - Experimental"},{"name":"CustomerArticles","x-displayName":"CustomerArticles"},{"name":"CustomerTags","x-displayName":"CustomerTags"},{"name":"Customers","x-displayName":"Customers"},{"name":"CustomFields","x-displayName":"CustomFields"},{"name":"DiscountTags","x-displayName":"DiscountTags"},{"name":"ExchangeRate","x-displayName":"ExchangeRate"},{"name":"Finance","x-displayName":"Finance"},{"name":"GiftCards","x-displayName":"GiftCards"},{"name":"RestHooksLog","x-displayName":"RestHooksLog"},{"name":"RestHooks","x-displayName":"RestHooks"},{"name":"Inventory levels","x-displayName":"Inventory levels"},{"name":"Loyalty","x-displayName":"Loyalty"},{"name":"Notifications","x-displayName":"Notifications"},{"name":"PartnerInventory","x-displayName":"PartnerInventory"},{"name":"PartnerPermissions","x-displayName":"PartnerPermissions"},{"name":"PaymentTypes","x-displayName":"PaymentTypes"},{"name":"PaymentTypeRelations","x-displayName":"PaymentTypeRelations"},{"name":"POSBalances","x-displayName":"POSBalances"},{"name":"POSPayments","x-displayName":"POSPayments"},{"name":"Cart","x-displayName":"Cart"},{"name":"pospaymentmaterialreturntag","x-displayName":"pospaymentmaterialreturntag"},{"name":"POSRegisters","x-displayName":"POSRegisters"},{"name":"ProductImage","x-displayName":"ProductImage"},{"name":"Products","x-displayName":"Products"},{"name":"ProductAddon","x-displayName":"ProductAddon"},{"name":"ProductMasterData","x-displayName":"ProductMasterData"},{"name":"ProductTags","x-displayName":"ProductTags"},{"name":"Promotions","x-displayName":"Promotions"},{"name":"RecurringPayment - Experimental","x-displayName":"RecurringPayment - Experimental"},{"name":"SalesOrderFulfillmentMaterials","x-displayName":"SalesOrderFulfillmentMaterials"},{"name":"SalesOrderFullfillments","x-displayName":"SalesOrderFullfillments"},{"name":"SalesOrdersMaterials","x-displayName":"SalesOrdersMaterials"},{"name":"SalesOrders","x-displayName":"SalesOrders"},{"name":"ServicePlan","x-displayName":"ServicePlan"},{"name":"ServiceSubscription","x-displayName":"ServiceSubscription"},{"name":"Settings","x-displayName":"Settings"},{"name":"ShoppingLists","x-displayName":"ShoppingLists"},{"name":"ShoppingListOrders","x-displayName":"ShoppingListOrders"},{"name":"StockTransactions","x-displayName":"StockTransactions"},{"name":"StockTransactionLists","x-displayName":"StockTransactionLists"},{"name":"StockTransactionTags","x-displayName":"StockTransactionTags"},{"name":"Suppliers","x-displayName":"Suppliers"},{"name":"TicketComments","x-displayName":"TicketComments"},{"name":"TicketFiles","x-displayName":"TicketFiles"},{"name":"TicketMaterials","x-displayName":"TicketMaterials"},{"name":"TicketTags","x-displayName":"TicketTags"},{"name":"Tickets","x-displayName":"Tickets"},{"name":"PaymentLink","x-displayName":"PaymentLink"},{"name":"ServiceNotifications","x-displayName":"ServiceNotifications"},{"name":"TicketTemplate","x-displayName":"TicketTemplate"},{"name":"TicketTemplateRelation","x-displayName":"TicketTemplateRelation"},{"name":"Users","x-displayName":"Users"},{"name":"VerifiedSupplier - Experimental","x-displayName":"VerifiedSupplier - Experimental"},{"name":"VerifiedSupplier","x-displayName":"VerifiedSupplier"}],"paths":{"/billing":{"get":{"tags":["Billing"],"summary":"Deprecated. Get billing data for the store","responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/BillingAccount"}}}}}}},"/bundle":{"post":{"tags":["Bundle - Experimental"],"operationId":"addBundle","requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/BundleRequest"}}}},"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/BundleResponse"}}}}}},"get":{"tags":["Bundle - Experimental"],"operationId":"Bundle","responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/SearchBundleResponse"}}}}}},"parameters":[{"in":"query","name":"paginationStart","schema":{"type":"integer","default":0},"example":100},{"in":"query","name":"paginationPageLength","schema":{"type":"integer","default":20,"maximum":200},"example":20}]},"/bundle/{id}":{"get":{"parameters":[{"in":"path","name":"id","schema":{"type":"integer"},"required":true}],"tags":["Bundle - Experimental"],"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/BundleResponse"}}}}}},"put":{"parameters":[{"in":"path","name":"id","schema":{"type":"integer"},"required":true}],"tags":["Bundle - Experimental"],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/BundleRequest"}}}},"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/BundleResponse"}}}}}},"delete":{"parameters":[{"in":"path","name":"id","schema":{"type":"integer"},"required":true}],"tags":["Bundle - Experimental"],"operationId":"deleteBundle","responses":{"204":{"description":"Ok"}}}},"/bundlefilter":{"post":{"tags":["BundleFilter - Experimental"],"operationId":"BundleFilter","requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/BundleFilterRequest"}}}},"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/BundleFilterResponse"}}}}}}},"/bundlefilter/{id}":{"get":{"parameters":[{"in":"path","name":"id","schema":{"type":"integer"},"required":true}],"tags":["BundleFilter - Experimental"],"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/BundleFilterResponse"}}}}}},"put":{"parameters":[{"in":"path","name":"id","schema":{"type":"integer"},"required":true}],"tags":["BundleFilter - Experimental"],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/BundleFilterRequest"}}}},"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/BundleFilterResponse"}}}}}},"delete":{"parameters":[{"in":"path","name":"id","schema":{"type":"integer"},"required":true}],"tags":["BundleFilter - Experimental"],"operationId":"deleteBundleFilter","responses":{"204":{"description":"Ok"}}}},"/customerarticles":{"get":{"tags":["CustomerArticles"],"summary":"Get list of customer articles","parameters":[{"in":"query","name":"serieno","schema":{"type":"string"},"example":"123abc"},{"in":"query","name":"paginationPageLength","schema":{"type":"integer","maximum":200}},{"in":"query","name":"customerid","schema":{"type":"integer"},"example":31241},{"in":"query","name":"freetext","schema":{"type":"string"},"example":"Bike Tyson"},{"in":"query","name":"allowdeleted","schema":{"type":"boolean"},"example":true},{"in":"query","name":"scope","schema":{"type":"string","enum":["sharecustomerarticles","sharecustomers"]}},{"in":"query","name":"updated_after","schema":{"type":"string"},"description":"Get all customer articles updated after the given date","example":"2020-01-01 00:00:00"}],"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/CustomerArticleListResponse"}}}}}},"post":{"tags":["CustomerArticles"],"summary":"Create a new customer article","operationId":"addCustomerArticle","requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/SetCustomerArticle"}}}},"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/CustomerArticleResponse"}}}}}}},"/customerarticles/delete":{"post":{"tags":["CustomerArticles"],"summary":"Delete customer articles","operationId":"deleteCustomerArticles","requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/BulkDeleteCustomerArticles"}}}},"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/BulkDeleteCustomerArticlesResponse"}}}},"404":{"description":"Not found"}}}},"/customerarticles/{id}/payments":{"parameters":[{"$ref":"#/components/parameters/id"}],"get":{"tags":["CustomerArticles"],"summary":"Get payments for a customer article","operationId":"listCustomerArticlePayments","description":"Returns a lightweight list of payments that contain the given customer article.","parameters":[{"in":"query","name":"paginationStart","schema":{"type":"integer","default":0}},{"in":"query","name":"paginationPageLength","schema":{"type":"integer","default":10,"maximum":25}}],"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/SearchPOSPaymentResponse"}}}},"4XX":{"description":"Bad request"}}}},"/customerarticles/{id}/switchcustomer":{"parameters":[{"$ref":"#/components/parameters/id"}],"put":{"tags":["CustomerArticles"],"summary":"Switch customer of a customer article","operationId":"switchCustomer","responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/CustomerArticleResponse"}}}}},"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/SwitchCustomerQuery"}}}}}},"/customerarticles/{id}":{"parameters":[{"$ref":"#/components/parameters/id"}],"get":{"tags":["CustomerArticles"],"summary":"Get a customer article","parameters":[{"in":"query","name":"allowdeleted","schema":{"type":"boolean"},"example":"true or 1"},{"in":"query","name":"withdraftsubscription","schema":{"type":"boolean"},"example":"true or 1"}],"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/CustomerArticleResponse"}}}}}},"put":{"tags":["CustomerArticles"],"summary":"Update a customer article","operationId":"updateCustomerArticle","requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/SetCustomerArticle"}}}},"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/CustomerArticleResponse"}}}}}},"delete":{"tags":["CustomerArticles"],"summary":"Delete a customer article","operationId":"deleteCustomerArticle","responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/CustomerArticleResponse"}}}}}}},"/customertags":{"get":{"tags":["CustomerTags"],"summary":"Get list of customer tags used by the store","operationId":"getCustomerTags","parameters":[{"in":"query","name":"freetext","schema":{"type":"string","description":"Search string"}},{"in":"query","name":"paginationStart","schema":{"type":"number","default":0,"description":"Start of pagination"}},{"in":"query","name":"paginationPageLength","schema":{"type":"number","description":"Pagination page length","default":1000}}],"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/CustomerTagsResponse"}}}}}},"post":{"tags":["CustomerTags"],"summary":"Add a new customer tag to the store","operationId":"createCustomerTag","requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/CustomerTag"}}}},"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/CustomerTagsResponse"}}}},"400":{"description":"Bad request"}}}},"/customertags/{tagId}":{"get":{"tags":["CustomerTags"],"summary":"Get a customer tag","operationId":"getCustomerTag","parameters":[{"in":"path","name":"tagId","schema":{"type":"integer"},"required":true,"description":"The tag ID"}],"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/CustomerTag"}}}}}},"delete":{"tags":["CustomerTags"],"summary":"Delete a customer tag from the store","operationId":"deleteCustomerTag","parameters":[{"in":"path","name":"tagId","schema":{"type":"integer"},"required":true,"description":"The tag ID"}],"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"type":"object"}}}}}},"put":{"tags":["CustomerTags"],"summary":"Update a customer tag","operationId":"updateCustomerTag","parameters":[{"in":"path","name":"tagId","required":true,"schema":{"type":"integer"},"description":"The tag ID"}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/CustomerTag"}}}},"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/CustomerTagsResponse"}}}},"404":{"description":"Not found"}}}},"/customers":{"get":{"tags":["Customers"],"summary":"Search for customers","description":"Lists customers of the authenticated store, optionally filtered and paginated. Drafts and deleted customers are excluded by default. Returns 400 for an unsupported `sortField` or an invalid request.","operationId":"searchCustomers","parameters":[{"in":"query","name":"paginationStart","schema":{"type":"integer","default":0},"example":100,"description":"Offset (in number of customers) to start from. This is usually a multiple of the paginationPageLength."},{"in":"query","name":"paginationPageLength","schema":{"type":"integer","default":50},"example":30,"description":"Number of customers to fetch in one page."},{"in":"query","name":"count","schema":{"type":"boolean"},"description":"If set, the total number of matching customers (ignoring pagination) is returned in `count`."},{"in":"query","name":"sortOrder","schema":{"type":"integer","enum":[-1,1],"default":1},"example":1,"description":"Sorting order. If 1, customers are retrieved in ascending order, if -1, in descending order."},{"in":"query","name":"customerno","schema":{"type":"string"},"description":"Filter customers by exact customer number"},{"in":"query","name":"sortField","schema":{"type":"string"},"example":"id","description":"Field to sort by. Supported values are id, storeid, name, phone, address, city, zipcode, addr_country, email, vat, ean, lat, lng, country, draft, createddate, updated_at, permission_marketing, customerno and balance. Other values result in a 400 response. If omitted, the store's default customer sort is used (if configured)."},{"in":"query","name":"allowMarketing","schema":{"type":"boolean"},"example":true,"description":"If true, only customers with marketing permission are returned. If false, only customers without."},{"in":"query","name":"name","schema":{"type":"string"},"description":"Search for customer name. Partial match."},{"in":"query","name":"email","schema":{"type":"string"},"description":"Search for customer email. Partial match."},{"in":"query","name":"phoneno","schema":{"type":"string"},"description":"Search for customer phone number. Matches the normalized (E.164) number or a partial match on the stored phone number."},{"in":"query","name":"ean","schema":{"type":"string"},"description":"Search for customer EAN. Partial match."},{"in":"query","name":"barcode","schema":{"type":"string"},"description":"Filter customers by exact barcode match"},{"in":"query","name":"cvr","schema":{"type":"string"},"description":"Search for customer CVR (VAT number). Partial match."},{"in":"query","name":"tags","schema":{"type":"string"},"description":"Customer tag IDs as a comma-separated string. Customers with any of the tags are returned. Ignored if `tag` is set."},{"in":"query","name":"tag","schema":{"type":"integer"},"description":"Only return customers with the given customer tag ID"},{"in":"query","name":"ids","schema":{"type":"string"},"description":"Customer IDs as a comma-separated string. Only these customers are returned."},{"in":"query","name":"freetext","schema":{"type":"string"},"description":"Freetext search for customer, this searches in most customer properties like name, address, phone, email etc"},{"in":"query","name":"partOfLoyaltyClub","schema":{"type":"boolean"},"description":"If true, only customers in the loyalty club are returned. If false, only customers not in the loyalty club."},{"in":"query","name":"updated_after","schema":{"type":"string"},"description":"Get all customers updated at or after the given date","example":"2020-01-01 00:00:00"}],"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/SearchCustomerResponse"}}}},"400":{"description":"Bad request, e.g. unsupported `sortField`","content":{"application/json":{"schema":{"type":"object"}}}}}},"post":{"tags":["Customers"],"summary":"Add a new customer","description":"","operationId":"addCustomer","requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/SetCustomer"}}}},"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/CustomerResponse"}}}},"400":{"description":"Bad request","content":{"application/json":{"schema":{"type":"object"}}}}}}},"/customers/{customerId}":{"get":{"summary":"Get a customer","operationId":"getCustomer","tags":["Customers"],"parameters":[{"in":"path","name":"customerId","schema":{"type":"integer"},"required":true,"description":"The customer ID"}],"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/CustomerResponse"}}}},"404":{"description":"Not found","content":{"application/json":{"schema":{"type":"string"}}}}}},"put":{"summary":"Replace a customer","operationId":"updateCustomer","tags":["Customers"],"parameters":[{"in":"path","name":"customerId","schema":{"type":"integer"},"required":true,"description":"The customer ID"}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/SetCustomer"}}}},"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/CustomerResponse"}}}},"404":{"description":"Not found"}}},"delete":{"summary":"Delete a customer","operationId":"deleteCustomer","tags":["Customers"],"parameters":[{"in":"path","name":"customerId","schema":{"type":"integer"},"required":true,"description":"The customer ID"}],"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/CustomerResponse"}}}},"404":{"description":"Not found"}}}},"/customfields":{"get":{"tags":["CustomFields"],"summary":"Get a list of all customfields.","parameters":[{"in":"query","name":"endpoint","schema":{"type":"string","default":"product"}}],"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/SearchCustomFieldResponse"}}}}}}},"/customfields/{endpoint}/{attribute}":{"put":{"tags":["CustomFields"],"description":"","summary":"Edit customfield","parameters":[{"in":"path","name":"endpoint","schema":{"type":"string","pattern":"^(product|customerarticle)$"},"required":true},{"in":"path","name":"attribute","schema":{"type":"string","pattern":"^customfield[1-4]$"},"required":true}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/CustomFieldRequest"}}}},"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/CustomFieldResponse"}}}},"4XX":{"description":"Not found"}}}},"/discounttags":{"post":{"tags":["DiscountTags"],"operationId":"addDiscountTag","requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/DiscountTagRequest"}}}},"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DiscountTagResponse"}}}}}},"get":{"tags":["DiscountTags"],"operationId":"DiscountTags","responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/SearchDiscountTagResponse"}}}}}}},"/discounttags/{id}":{"put":{"parameters":[{"in":"path","name":"id","schema":{"type":"integer"},"required":true}],"tags":["DiscountTags"],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/DiscountTagRequest"}}}},"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DiscountTagResponse"}}}}}},"delete":{"parameters":[{"in":"path","name":"id","schema":{"type":"integer"},"required":true}],"tags":["DiscountTags"],"operationId":"discounttags","responses":{"204":{"description":"Ok"}}}},"/exchangerate":{"get":{"tags":["ExchangeRate"],"summary":"Get all exchange rates created by the store","responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ExchangeRateListResponse"}}}}}},"post":{"tags":["ExchangeRate"],"summary":"Create a new exchange rate","requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ExchangeRateRequest"}}}},"responses":{"201":{"description":"Created","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ExchangeRateResponse"}}}}}}},"/exchangerate/{id}":{"get":{"tags":["ExchangeRate"],"summary":"Get an exchange rate by ID","parameters":[{"name":"id","in":"path","required":true,"schema":{"type":"integer"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ExchangeRateResponse"}}}}}},"put":{"tags":["ExchangeRate"],"summary":"Update an existing exchange rate","parameters":[{"name":"id","in":"path","required":true,"schema":{"type":"integer"}}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ExchangeRateRequest"}}}},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ExchangeRateResponse"}}}}}},"delete":{"tags":["ExchangeRate"],"summary":"Delete an exchange rate","parameters":[{"name":"id","in":"path","required":true,"schema":{"type":"integer"}}],"responses":{"204":{"description":"No Content"}}}},"/financevouchers/{balanceId}":{"get":{"tags":["Finance"],"summary":"Get finance voucher for a balance","parameters":[{"$ref":"#/components/parameters/balanceId"},{"in":"query","name":"excludeInvoicePayment","required":false,"schema":{"type":"boolean"},"description":"Exclude invoice in the response"},{"in":"query","name":"excludeCustomerPayment","required":false,"schema":{"type":"boolean"},"description":"Exclude customer payment in the response"}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/FinanceVoucher"}}}}}}}},"/giftcards":{"get":{"tags":["GiftCards"],"description":"Search for giftcards","operationId":"searchGiftcard","parameters":[{"in":"query","name":"freetext","schema":{"type":"string"},"description":"The free text that is used to search in name, type, giftcardno, phone etc."},{"in":"query","name":"fromdate","schema":{"type":"string"},"description":"date","example":"2020-01-01 00:00:00"},{"in":"query","name":"todate","schema":{"type":"string"},"description":"date","example":"2020-01-01 23:59:59"},{"in":"query","name":"giftcardid","schema":{"type":"integer"},"description":"filter on id"},{"in":"query","name":"customerid","schema":{"type":"integer"},"description":"filter on customerid"},{"in":"query","name":"giftcardno","schema":{"type":"string"},"description":"filter on id"},{"in":"query","name":"paginationStart","schema":{"type":"integer","default":0},"example":100,"description":"Determine the offset (in number of item) to fetch. This is usually a multiple of the pageLength."},{"in":"query","name":"paginationPageLength","schema":{"type":"integer","default":50},"example":30,"description":"Determine the number of items to fetch in one page."},{"in":"query","name":"sortOrder","schema":{"type":"integer","enum":[-1,1],"default":1},"example":1,"description":"Sorting order. If `order` is 1, items are retrieved in ascending order, if -1, in descending order."},{"in":"query","name":"sortField","schema":{"type":"string"},"example":"id","description":"Sort by `field` e.g. giftcardno, date,.."}],"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/SearchGiftcardsResponse"}}}}}},"post":{"tags":["GiftCards"],"description":"Create a giftcard","operationId":"createGiftcard","requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/PostGiftcardsRequest"},"examples":{"AddGiftcard":{"value":{"content":{"giftcardno":"1234","amount":200}},"description":"Create a giftcard with amount of 200"},"AddGiftcardWithCustomer":{"value":{"content":{"giftcardno":"1234","amount":200,"customerid":123}},"description":"Create a giftcard with amount of 200 and connect customer with customerid 123"}}}}},"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PostGiftcardsResponse"},"examples":{"AddGiftcard":{"value":{"content":{"id":27660,"giftcardno":"1234","amount":200,"amountspent":0,"createddate":"2022-01-20 09:20:34","expirationdate":"2025-01-20 09:20:34","paymentid":null,"type":"giftcard","vat":null,"productid":null,"productno":null,"expired":false,"store":{"id":198},"customer":null}},"description":"Add a giftcard with amount of 200"}}}}},"4XX":{"description":"Bad request"}}}},"/giftcards/{giftcardId}":{"put":{"tags":["GiftCards"],"description":"Update a giftcard","parameters":[{"in":"path","name":"giftcardId","schema":{"type":"integer"},"required":true,"description":"The giftcard ID"}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/PutGiftcardRequest"},"examples":{"UpdateAmountSpent":{"value":{"content":{"amountspent":80}},"description":"Set the amount spent on a giftcard to 80 and leave the balance at 120"},"UpdateGiftCardHolder":{"value":{"content":{"customerid":123}},"description":"Set the current customer of the giftcard to customerId 123"}}}}},"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PutGiftcardsResponse"},"examples":{"UpdateAmountSpent":{"value":{"content":{"id":27660,"giftcardno":"1234","amount":200,"amountspent":80,"createddate":"2022-01-20 09:20:34","expirationdate":"2025-01-20 09:20:34","paymentid":null,"type":"giftcard","vat":null,"productid":null,"productno":null,"expired":false,"store":{"id":198}}}}}}}},"4XX":{"description":"ok"}}},"get":{"tags":["GiftCards"],"description":"Get giftcards","operationId":"getGiftcard","parameters":[{"in":"path","name":"giftcardId","schema":{"type":"integer"},"required":true,"description":"The giftcard id"}],"responses":{"200":{"description":"Ok. The created giftcard is returned in the response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/GetGiftcardResponse"}}}},"404":{"description":"Giftcard not found."}}}},"/giftcards/{giftcardid}/transactions":{"get":{"tags":["GiftCards"],"description":"Get all transactions for a given giftcard","parameters":[{"in":"path","name":"giftcardid","schema":{"type":"integer"},"required":true,"description":"The giftcard id"}],"responses":{"200":{"description":"Ok. The transactions for the giftcard is returned in the response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/GetGiftCardTransactionsResponse"}}}},"404":{"description":"Giftcard not found"}}}},"/hooks/log":{"get":{"tags":["RestHooksLog"],"summary":"List current REST hook log entries for store.","description":"","responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/RestHookLogResponse"}}}}}}},"/hooks/events":{"get":{"summary":"Get the list of valid events.","tags":["RestHooks"],"responses":{"200":{"description":"List of valid rest hook events","content":{"application/json":{"schema":{"$ref":"#/components/schemas/RestHookEventResponse"}}}}}}},"/hooks":{"get":{"tags":["RestHooks"],"summary":"List current subscriptions for store.","description":"","responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/RestHookResponse"}}}}}},"post":{"tags":["RestHooks"],"summary":"Subscribe to event","description":"Subscribe to an event like product.created with a callback url to get pinged when the event triggers.","requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/RestHook"}}}},"responses":{"201":{"description":"Added","content":{"application/json":{"schema":{"type":"object","description":"The hook information returned when subscribing to an an event.","properties":{"id":{"description":"The id needed to unsubscribe.","type":"integer","example":1}},"additionalProperties":false}}},"links":{"unsubscribeOp":{"operationId":"unsubscribe","parameters":{"hookId":"$response.body#/id"},"description":"The `id` returned in the response is used as the parameter `hookId` in `DELETE /hooks/{hookId}`"}}},"4XX":{"description":"Invalid input"}},"callbacks":{"callback":{"{$request.body#/url}":{"post":{"requestBody":{"content":{"application/json":{}}},"responses":{"200":{"description":"Ok"}}}}}}}},"/hooks/{hookId}":{"get":{"operationId":"getSubscription","tags":["RestHooks"],"summary":"Get subscription","description":"Get the subscription details for given an id.","parameters":[{"in":"path","name":"hookId","required":true,"schema":{"type":"integer"}}],"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/RestHook"}}}},"4XX":{"description":"Not found"}}},"put":{"operationId":"updateSubscription","tags":["RestHooks"],"summary":"Update subscription","description":"Update the subscription for an event given an id.","parameters":[{"in":"path","name":"hookId","required":true,"schema":{"type":"integer"}}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/RestHook"}}}},"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"type":"object","description":"The status of the subscription update.","properties":{"updated":{"type":"integer","example":1,"description":"Whether or not the event was updated. 0 for failure, 1 for success."}},"additionalProperties":false}}}},"4XX":{"description":"Invalid input"}}},"delete":{"operationId":"unsubscribe","tags":["RestHooks"],"summary":"Unsubscribe from event","description":"Unsubscribe from an event given an id for subscription.","parameters":[{"in":"path","name":"hookId","required":true,"schema":{"type":"integer"}}],"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"type":"object","additionalProperties":false,"description":"The status of the subscription deletion.","properties":{"deleted":{"type":"integer","example":1,"description":"Whether or not the event was deleted. 0 for failure, 1 for success."}}}}}}}}},"/inventorylevels":{"get":{"description":"List the current inventory level for products","operationId":"InventoryLevelList","tags":["Inventory levels"],"parameters":[{"$ref":"#/components/parameters/cursor"},{"$ref":"#/components/parameters/updated_after"},{"in":"query","name":"product_id","schema":{"type":"integer"}},{"in":"query","name":"product_no","schema":{"type":"string"}},{"in":"query","name":"exclude_zero","schema":{"type":"boolean","default":false}},{"in":"query","name":"per_page","schema":{"type":"integer","default":50,"minimum":0,"maximum":1000}}],"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/InventoryLevelSearchResponse"}}}}}},"patch":{"description":"Update inventory level for a product","operationId":"InventoryLevelPatch","tags":["Inventory levels"],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/InventoryLevelUpdateRequest"}}}},"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"type":"object","properties":{"content":{"$ref":"#/components/schemas/InventoryLevel"}},"additionalProperties":false}}}}}}},"/loyalty/customer/{id}/membership":{"parameters":[{"$ref":"#/components/parameters/id"}],"delete":{"tags":["Loyalty"],"summary":"Withdraw a customer from the loyalty program","responses":{"204":{"description":"Ok"}}},"post":{"tags":["Loyalty"],"summary":"Enroll a customer into the loyalty program","responses":{"204":{"description":"Ok"}}}},"/loyalty/customer/{id}":{"parameters":[{"$ref":"#/components/parameters/id"}],"get":{"tags":["Loyalty"],"summary":"Get loyalty transactions of the customer","parameters":[{"in":"query","name":"paginationStart","schema":{"type":"number","default":0,"description":"Start of pagination"}},{"in":"query","name":"paginationPageLength","schema":{"type":"number","description":"Pagination page length","default":1000}}],"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/LoyaltyTransactionsResponse"}}}}}},"post":{"tags":["Loyalty"],"summary":"Create a new transaction on this user","requestBody":{"required":true,"content":{"application/json":{"schema":{"properties":{"content":{"$ref":"#/components/schemas/CreateLoyaltyTransactionRequest"}}}}}},"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/LoyaltyTransactionResponse"}}}}}}},"/notifications":{"get":{"tags":["Notifications"],"summary":"Get recent notifications for the current user","parameters":[{"in":"query","name":"userid","schema":{"type":"integer"},"description":"The user ID"},{"in":"query","name":"updated_after","schema":{"type":"string"},"description":"Get alle notification updated after a certain date"},{"in":"query","name":"created_after","schema":{"type":"string"},"description":"Get alle notification created after a certain date"}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/NotificationsResponse"}}}}}},"post":{"tags":["Notifications"],"summary":"Create notification","requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/NotificationCreateRequest"}}}},"responses":{"200":{"description":"Created","content":{"application/json":{"schema":{"$ref":"#/components/schemas/NotificationCreateResponse"}}}}}}},"/notifications/settings":{"get":{"tags":["Notifications"],"summary":"Get the settings object describing which users are listening to what notifications","responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"object","additionalProperties":true}}}}}},"put":{"tags":["Notifications"],"summary":"Update the settings object describing which users are listening to what notifications","requestBody":{"required":true,"content":{"application/json":{"schema":{"type":"object"}}}},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"object","additionalProperties":true}}}}}}},"/notifications/settings/{channel}":{"parameters":[{"name":"channel","in":"path","required":true,"schema":{"type":"string","enum":["sms","mail"]}}],"get":{"tags":["Notifications"],"summary":"Get which users receive which notifications on a channel","description":"Maps each notification type to the ids of the users receiving it by SMS or email in addition to in-app.","responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"object","description":"Notification type mapped to the ids of the users receiving it on the channel","additionalProperties":{"type":"array","items":{"type":"integer"}}}}}}}},"put":{"tags":["Notifications"],"summary":"Turn a channel on or off for one user and notification type","description":"Channels are add-ons to the in-app subscription, so enabling a channel for a user who isn't subscribed in-app is rejected, and unsubscribing in-app also stops the channel. The main user can change any user, other users only themselves.","requestBody":{"required":true,"content":{"application/json":{"schema":{"type":"object","additionalProperties":false,"required":["notification","userid","enabled"],"properties":{"notification":{"type":"string","example":"App\\Notifications\\ProductStockBelowMinimum"},"userid":{"type":"integer"},"enabled":{"type":"boolean"}}}}}},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"object","description":"Notification type mapped to the ids of the users receiving it on the channel","additionalProperties":{"type":"array","items":{"type":"integer"}}}}}},"4XX":{"description":"403 if a non-main user changes another user's channels, 422 if the user isn't subscribed to the notification in-app"}}}},"/partnerinventory/{productid}":{"get":{"parameters":[{"in":"path","name":"productid","schema":{"type":"integer"},"required":true,"description":"The product ID"}],"tags":["PartnerInventory"],"description":"Get inventory levels for partner stores matched on product number. If a product has serial products the endpoint will return the inventory sum of all those serial products\n","responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PartnerInventoryResponse"}}}},"4XX":{"description":"Bad request"}}}},"/partnerpermissions/derived":{"get":{"tags":["PartnerPermissions"],"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PartnerPermissionDerivedResponse"}}}}}}},"/paymenttypes":{"get":{"tags":["PaymentTypes"],"description":"","summary":"Get a list of all the store's payment types.","responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/PaymentType"}}}}}}},"post":{"tags":["PaymentTypes"],"description":"","summary":"Create a payment type","requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/PaymentType"}}}},"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PaymentType"}}}}}}},"/paymenttypes/{id}":{"get":{"tags":["PaymentTypes"],"parameters":[{"in":"path","name":"id","schema":{"type":"integer"},"required":true},{"in":"query","name":"allowDeleted","schema":{"type":"integer"},"required":false,"description":"Includes deleted payment types in the response when not 0"}],"description":"","summary":"Get a list of all the store's payment types.","responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PaymentType"}}}},"4XX":{"description":"Not found"}}},"put":{"tags":["PaymentTypes"],"description":"","summary":"Edit an exisiting payment type","parameters":[{"in":"path","name":"id","schema":{"type":"integer"},"required":true,"description":"The PaymentType ID"},{"in":"query","name":"allowDeleted","schema":{"type":"integer"},"required":false,"description":"Allows for settings deleted payment types when not 0"}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/PaymentType"}}}},"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PaymentType"}}}},"4XX":{"description":"Not found"}}},"delete":{"tags":["PaymentTypes"],"description":"","summary":"Delete a payment type","parameters":[{"in":"path","name":"id","schema":{"type":"integer"},"required":true,"description":"The PaymentType ID"}],"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"type":"object","properties":{"deleted":{"type":"integer","readOnly":true,"example":1,"description":"Whether or not the PaymentType was deleted."}},"additionalProperties":false}}}},"4XX":{"description":"Bad request"}}}},"/paymenttyperelation/{paymentId}":{"parameters":[{"$ref":"#/components/parameters/paymentId"}],"get":{"tags":["PaymentTypeRelations"],"parameters":[{"in":"query","name":"getreceipts","schema":{"type":"boolean"},"required":false,"description":"Whether or not to include receipts"}],"summary":"Add a list of articles to an existing payment","description":"","operationId":"getPaymentTypes","responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/PaymentTypeRelation"}}}}}}},"post":{"tags":["PaymentTypeRelations"],"summary":"Add a list of payments to an existing payment","description":"","operationId":"addPaymentTypes","requestBody":{"required":true,"content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/PaymentTypeRelation"}}}}},"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/PaymentTypeRelation"}}}}},"404":{"description":"The payment you are trying to add paymenttypes to does not exist."}}},"put":{"tags":["PaymentTypeRelations"],"summary":"Changes status of a payment","description":"Can only change the status of a payment if it is not captured","requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/PaymentTypeRelation"}}}},"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PaymentTypeRelation"}}}},"4XX":{"description":"Not found"}}}},"/paymenttyperelation/{id}/receipts":{"get":{"tags":["PaymentTypeRelations"],"parameters":[{"in":"path","name":"id","schema":{"type":"integer"},"required":true,"description":"The ID"}],"summary":"Gets receipt for a paymenttyperelation","description":"","operationId":"getPaymentTypeReceipts","responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"type":"array","items":{"type":"string"}}}}}}}},"/posbalances":{"get":{"tags":["POSBalances"],"summary":"Search for balances","description":"Get balances. Balances are readonly and can only be created via Customers 1st app","operationId":"searchBalances","parameters":[{"in":"query","name":"paginationStart","schema":{"type":"integer","default":0},"example":100,"description":"Determine the offset (in number of item) to fetch. This is usually a multiple of the pageLength."},{"in":"query","name":"paginationPageLength","schema":{"type":"integer","default":50},"example":30,"description":"Determine the number of items to fetch in one page."},{"in":"query","name":"sortOrder","schema":{"type":"integer","enum":[-1,1],"default":1},"example":1,"description":"Sorting order. If `order` is 1, items are retrieved in ascending order, if -1, in descending order."},{"in":"query","name":"sortField","schema":{"type":"string"},"example":"id","description":"Sort by `field` e.g. date,..."},{"in":"query","name":"userId","schema":{"type":"integer"},"example":1,"description":"Id of the cashier"},{"in":"query","name":"cashRegisterId","schema":{"type":"integer"},"example":2,"description":"Id of the cash register"},{"in":"query","name":"toDate","schema":{"type":"string"},"description":"Get all payments before the given date","example":"2020-01-01 23:59:59"},{"in":"query","name":"fromDate","schema":{"type":"string"},"description":"Get all payments after the given date","example":"2020-01-01 23:59:59"}],"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/SearchPOSBalanceResponse"}}}}}}},"/pospayments/{paymentId}/articles":{"parameters":[{"$ref":"#/components/parameters/paymentId"}],"post":{"tags":["POSPayments"],"summary":"Add a list of articles to an existing payment.","description":"","operationId":"addArticles","requestBody":{"required":true,"content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/PaymentArticle"}}}}},"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/PaymentArticle"}}}}},"404":{"description":"The payment you are trying to add articles to does exist"}}}},"/pospayments/{paymentId}/articles/{paymentArticleId}":{"parameters":[{"$ref":"#/components/parameters/paymentId"},{"$ref":"#/components/parameters/paymentArticleId"}],"put":{"tags":["Cart"],"summary":"a new cart.","requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/PaymentArticleRequest"}}}},"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PaymentArticleResponse"}}}},"4XX":{"description":"Not found"}}},"delete":{"tags":["Cart"],"summary":"a new cart.","responses":{"204":{"description":"Ok"},"4XX":{"description":"Not found"}}}},"/pospayments/{paymentId}/articles/{paymentArticleId}/discount":{"parameters":[{"$ref":"#/components/parameters/paymentArticleId"},{"$ref":"#/components/parameters/paymentId"}],"post":{"tags":["Cart"],"summary":"Add a discount to a specific article in a payment.","requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/DiscountArticleItem"}}}},"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PaymentArticle"}}}},"4XX":{"description":"Not found"}}}},"/pospayments/{paymentId}/articles/discount":{"parameters":[{"$ref":"#/components/parameters/paymentId"}],"post":{"tags":["Cart"],"summary":"a new cart.","requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/DiscountArticleItem"}}}},"responses":{"204":{"description":"Ok"},"4XX":{"description":"Not found"}}}},"/pospayments/materialreturntags":{"get":{"tags":["pospaymentmaterialreturntag"],"summary":"List all material return tags","responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PaymentMaterialReturnTagsResponse"}}}}}}},"/pospayments":{"get":{"tags":["POSPayments"],"summary":"Search for payments","description":"Get payments.","operationId":"searchPosPayments","parameters":[{"in":"query","name":"freetext","deprecated":true,"schema":{"type":"string"},"description":"The free text that is used to search in paymentno, payment materials, etc."},{"in":"query","name":"note","schema":{"type":"string"},"description":"Search based on notes."},{"in":"query","name":"fromdate","schema":{"type":"string"},"description":"Get all payments after the given fromdate to now (or to todate if specified)","example":"2020-01-01 00:00:00"},{"in":"query","name":"cash","schema":{"type":"integer"},"description":"1 of you only want cash payments"},{"in":"query","name":"invoice","schema":{"type":"integer"},"description":"1 of you only want invoice payments","example":1},{"in":"query","name":"todate","schema":{"type":"string"},"description":"Get all payments before the given todate","example":"2020-01-01 23:59:59"},{"in":"query","name":"productid","schema":{"type":"integer"},"description":"Get payments of a specific product"},{"in":"query","name":"discounttagid","schema":{"type":"integer"},"description":"Get payments with an article discounted using a specific discount tag"},{"in":"query","name":"paymentno_after","schema":{"type":"integer","minimum":0},"description":"Get all payments with paymentno >= paymentno_after"},{"in":"query","name":"updated_after","schema":{"type":"string"},"description":"Get all payments updated after the given date","example":"2020-01-01 00:00:00"},{"in":"query","name":"userid","schema":{"type":"integer"},"description":"filter on userid"},{"in":"query","name":"customerid","schema":{"type":"integer"},"description":"filter on customerid"},{"in":"query","name":"customerPaymentSum","schema":{"type":"integer","default":0},"description":"Calculate total payment sum for customer, requires that customerid is provided"},{"in":"query","name":"paymenttypeid","schema":{"type":"integer"},"description":"Filter on paymenttype"},{"in":"query","name":"sum","deprecated":true,"schema":{"type":"number","format":"double"},"description":"Deprecated: Use sumFrom and sumTo instead. Filter payments with exact sum match."},{"in":"query","name":"sumFrom","schema":{"type":"number","format":"double"},"description":"Filter payments with sum greater than or equal to this value"},{"in":"query","name":"sumTo","schema":{"type":"number","format":"double"},"description":"Filter payments with sum less than or equal to this value"},{"in":"query","name":"returnPaymentsOnly","schema":{"type":"boolean"},"description":"Filter to only include payments where articles are being returned (i.e. quantity < 0)"},{"in":"query","name":"paymentno","schema":{"type":"string"},"description":"Filter on paymentno"},{"in":"query","name":"paymentid","schema":{"type":"integer"},"description":"Filter on payment"},{"in":"query","name":"bamdeskdevice","schema":{"type":"integer"},"description":"1 = only get bamdeskdevice payments"},{"in":"query","name":"fromPartnerStores","schema":{"type":"integer","default":0},"description":"Includes payments from partner stores when not 0","example":1},{"in":"query","name":"paginationStart","schema":{"type":"integer","default":0},"example":100,"description":"Determine the offset (in number of item) to fetch. This is usually a multiple of the pageLength."},{"in":"query","name":"paginationPageLength","schema":{"type":"integer","default":50},"example":30,"description":"Determine the number of items to fetch in one page."},{"in":"query","name":"sortOrder","schema":{"type":"integer","enum":[-1,1],"default":1},"example":1,"description":"Sorting order. If `order` is 1, items are retrieved in ascending order, if -1, in descending order."},{"in":"query","name":"sortField","schema":{"type":"string"},"example":"id","description":"Sort by `field` e.g. paymentno, date,."},{"in":"query","name":"cashRegisterId","schema":{"type":"number"},"example":1,"description":"Get payments with a specific cash register"},{"in":"query","name":"status","schema":{"$ref":"#/components/schemas/PaymentStatus"},"example":"completed","description":"Get payments with a specific status"}],"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/SearchPOSPaymentResponse"}}}}}},"post":{"tags":["POSPayments"],"summary":"Add a new POS payment","description":"Add a new payment. For a payment use must provide the products sold via articles and the payment transactions via paymenttypes","operationId":"addPayment","requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/POSPayment"},"examples":{"Wine":{"value":{"articles":[{"title":"Vin","price":100,"costprice":30,"quantity":1,"productno":"zinfandel_123","vat":25}],"paymenttypes":[{"title":"Cash","amount":100,"cash":1}]},"description":"Sell wine with cash payment"}}}}},"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/POSPayment"}}}}}}},"/pospayments/{paymentId}":{"parameters":[{"$ref":"#/components/parameters/paymentId"}],"get":{"summary":"Get a payment","description":"Get a single payment, including its extra details (e.g. materials and payment types). Payments of stores sharing gift cards with the current store are also returned.","operationId":"getPOSPayment","tags":["POSPayments"],"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/POSPaymentResponse"}}}},"4XX":{"description":"Payment not found."}}},"put":{"summary":"Changes payment","operationId":"putPOSPayment","tags":["POSPayments"],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/POSPaymentRequest"}}}},"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/POSPaymentResponse"}}}},"4XX":{"description":"Not found"}}}},"/registers":{"get":{"tags":["POSRegisters"],"description":"","summary":"Get a list of all the store's POS registers.","parameters":[{"in":"query","name":"includeDeleted","required":false,"schema":{"type":"boolean","default":false,"description":"Include deleted cash registers in request"}}],"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/POSRegisterResponse"}}}}}},"post":{"tags":["POSRegisters"],"description":"","summary":"Create a new POSRegister","requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/SetPOSRegister"}}}},"responses":{"201":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/SetPOSRegisterResponse"}}}}}}},"/registers/{id}":{"parameters":[{"$ref":"#/components/parameters/id"}],"put":{"tags":["POSRegisters"],"description":"","summary":"Edit an exisiting POS register","requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/SetPOSRegister"}}}},"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/SetPOSRegisterResponse"}}}}}},"get":{"tags":["POSRegisters"],"summary":"Get a POS register based on id","responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/SetPOSRegisterResponse"}}}},"4XX":{"description":"Not found"}}},"delete":{"tags":["POSRegisters"],"summary":"Deletes a POS register based on id","responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/SetPOSRegisterResponse"}}}},"4XX":{"description":"Not found"}}}},"/products/{id}/image":{"parameters":[{"$ref":"#/components/parameters/id"}],"get":{"tags":["ProductImage"],"summary":"Get a products image","responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ProductImageResponse"}}}}}},"delete":{"tags":["ProductImage"],"summary":"Delete a products image","responses":{"204":{"description":"No content"}}}},"/products/{id}/image/url":{"parameters":[{"$ref":"#/components/parameters/id"}],"post":{"tags":["ProductImage"],"summary":"Set a product image from a url. This is done Async.","requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/SetProductImageFromURL"}}}},"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ProductImageResponse"}}}}}}},"/products/{id}/addons":{"get":{"tags":["Products"],"summary":"Get addons for a specific product","description":"","operationId":"getProductAddons","parameters":[{"in":"path","name":"id","schema":{"type":"integer"},"required":true,"description":"The product ID"},{"in":"query","name":"paginationStart","schema":{"type":"integer","default":0},"example":100,"description":"Determine the offset (in number of products) to fetch. This is usually a multiple of the pageLength. For legacy support you can also write pagination-start"},{"in":"query","name":"paginationPageLength","schema":{"type":"integer","default":50,"maximum":250},"example":30,"description":"Determine the number of products to fetch in one page. For legacy support you can also write pagination-PageLength"}],"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/AddonListResponse"}}}},"4XX":{"description":"Not found"}}},"post":{"parameters":[{"$ref":"#/components/parameters/id"}],"tags":["Products"],"summary":"Add a new add-on to a specific product","description":"","operationId":"addProductAddon","requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/AddAddon"}}}},"responses":{"204":{"description":"Ok"},"405":{"description":"Invalid input"}}}},"/products/{productId}/addons/{addonId}":{"put":{"summary":"Edit a addon relation","operationId":"putProductAddonRelation","tags":["ProductAddon"],"parameters":[{"in":"path","name":"productId","schema":{"type":"integer"},"required":true,"description":"The product ID"},{"in":"path","name":"addonId","schema":{"type":"integer"},"required":true,"description":"The add-on id"}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ProductAddon"}}}},"responses":{"204":{"description":"Ok"},"4XX":{"description":"Not found"}}},"delete":{"summary":"Delete a specific addon for a specific product","operationId":"deleteProductAddon","tags":["ProductAddon"],"parameters":[{"in":"path","name":"productId","schema":{"type":"integer"},"required":true,"description":"The product ID"},{"in":"path","name":"addonId","schema":{"type":"integer"},"required":true,"description":"The add-on id"}],"responses":{"204":{"description":"Ok"},"4XX":{"description":"Not found"}}}},"/products/{id}/addons/count":{"get":{"tags":["Products"],"summary":"Get the number of addons for a specific product","description":"","operationId":"countProductAddons","parameters":[{"in":"path","name":"id","schema":{"type":"integer"},"required":true,"description":"The product ID"}],"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/CountAddonsResponse"}}}},"4XX":{"description":"Not found"}}}},"/products/bulk":{"put":{"tags":["Products"],"summary":"Replace products in chunks","description":"","operationId":"replaceProductBulk","requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/SetProductBulk"}}}},"responses":{"200":{"description":"The endpoint always return 200","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ProductResponseBulk"}}}}}},"patch":{"tags":["Products"],"summary":"Patch products in bulk","description":"","operationId":"updateProductBulk","requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/SetProductBulk"}}}},"responses":{"200":{"description":"The endpoint always return 200","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ProductResponseBulk"}}}}}},"delete":{"tags":["Products"],"summary":"Delete products in chunks","description":"","operationId":"deleteProductBulk","parameters":[{"in":"query","name":"ids","style":"pipeDelimited","schema":{"type":"array","maxItems":100,"items":{"type":"string"}},"description":"Pipe separated list of ids"}],"responses":{"200":{"description":"The endpoint always return 200","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ProductResponseBulk"}}}}}}},"/productmasterdata":{"post":{"tags":["ProductMasterData"],"summary":"Add or update product master data. Update is triggered if {suppliername, productno, industry, country} matches existing item","description":"","operationId":"addProductMasterdata","requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ProductMasterData"}}}},"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ProductMasterDataResponse"}}}},"4XX":{"description":"Failed"}}},"get":{"tags":["ProductMasterData"],"summary":"Search the productmasterdata","description":"","operationId":"searchProductMasterData","parameters":[{"in":"query","name":"search","schema":{"type":"string"},"description":"The search string"},{"in":"query","name":"barcode","schema":{"type":"string"},"description":"A secondary search string that only searches in the barcode field"},{"in":"query","name":"productno","schema":{"type":"string"},"description":"A search string that searches in the productno field"},{"in":"query","name":"pagelength","schema":{"type":"integer"},"description":"The pagination page length"},{"in":"query","name":"offset","schema":{"type":"integer"},"description":"The pagination object offset"}],"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"type":"object","properties":{"content":{"type":"array","items":{"$ref":"#/components/schemas/ProductMasterData"}},"hasMore":{"type":"boolean"}},"additionalProperties":false}}}},"4XX":{"description":"Failed"}}}},"/productmasterdata/bulk":{"post":{"tags":["ProductMasterData"],"summary":"Add or update product master data in bulk. Update is triggered if {suppliername, productno, industry, country} matches existing item","description":"","operationId":"addUpdateBulk","requestBody":{"required":true,"content":{"application/json":{"schema":{"type":"array","maxItems":1000,"items":{"$ref":"#/components/schemas/ProductMasterData"}}}}},"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/ProductMasterDataResponse"}}}}},"4XX":{"description":"Failed"}}}},"/products":{"get":{"tags":["Products"],"summary":"Search for product","description":"","operationId":"searchProduct","parameters":[{"$ref":"#/components/parameters/cursor"},{"in":"query","name":"barcode","schema":{"type":"string"},"description":"Barcode. Matches exactly on the barcode (also with leading zeros/`¤` trimmed). If nothing is found, alternative barcodes are searched as well."},{"in":"query","name":"title","schema":{"type":"string"},"description":"Product title. Partial match."},{"in":"query","name":"brand","schema":{"type":"string"},"description":"Brand. Partial match."},{"in":"query","name":"color","schema":{"type":"string"},"description":"Color. Partial match."},{"in":"query","name":"size","schema":{"type":"string"},"description":"Size. Partial match."},{"in":"query","name":"customfield1","schema":{"type":"string"},"description":"Value of custom field 1. Partial match."},{"in":"query","name":"customfield2","schema":{"type":"string"},"description":"Value of custom field 2. Partial match."},{"in":"query","name":"customfield3","schema":{"type":"string"},"description":"Value of custom field 3. Partial match."},{"in":"query","name":"customfield4","schema":{"type":"string"},"description":"Value of custom field 4. Partial match."},{"in":"query","name":"freetext","schema":{"type":"string"},"description":"Freetext search used to find what humans expect. NB this can change over time, don't use this in your integration on this."},{"in":"query","name":"id","schema":{"type":"integer"},"description":"The ID of the product."},{"in":"query","name":"ids","schema":{"type":"array","items":{"type":"integer"}},"style":"form","explode":true,"description":"Only retrieve products with one of these IDs. Must be sent with bracket syntax, `ids[]=1&ids[]=2`; repeated `ids=` parameters are not supported."},{"in":"query","name":"count","schema":{"type":"boolean","default":false},"description":"If true, the total number of matching products (ignoring pagination) is returned in `count`."},{"in":"query","name":"allowDeleted","schema":{"type":"boolean","default":false},"description":"Include deleted products."},{"in":"query","name":"notInStock","schema":{"type":"boolean"},"description":"Only retrieve products that are not in stock (stock is zero or negative)."},{"in":"query","name":"available","schema":{"type":"boolean"},"description":"Only retrieve products with available stock (stock not reserved by sales orders or tickets)."},{"in":"query","name":"reserved","schema":{"type":"boolean"},"description":"Only retrieve products with stock reserved by sales orders or tickets (and with inventory tracking)."},{"in":"query","name":"notsold","schema":{"type":"boolean"},"description":"Exclude products that have been sold in POS and are no longer in stock."},{"in":"query","name":"excludeserialproducts","schema":{"type":"boolean"},"description":"Exclude products that have a serie-number."},{"in":"query","name":"hasPrice","schema":{"type":"boolean"},"description":"Only retrieve products with a price greater than zero."},{"in":"query","name":"hasBarcode","schema":{"type":"boolean"},"description":"Only retrieve products that have a barcode."},{"in":"query","name":"styleGroup","schema":{"type":"string"},"description":"Only retrieve products belonging to this style group."},{"in":"query","name":"inStock","schema":{"type":"boolean"},"description":"Only retrieve products that are currently in stock."},{"in":"query","name":"needsOrdering","schema":{"type":"boolean"},"description":"Only retrieve products that needs to be ordered because of low stock."},{"in":"query","name":"paginationStart","deprecated":true,"schema":{"type":"integer","default":0},"example":100,"description":"Deprecated, use `cursor` instead. Determine the offset (in number of products) to fetch. This is usually a multiple of the pageLength. For legacy support `pagination-start` is also accepted."},{"in":"query","name":"paginationPageLength","schema":{"type":"integer","default":50,"maximum":250},"example":30,"description":"Determine the number of products to fetch in one page. Default is 50. For legacy support `pagination-pageLength` is also accepted (the backend is case-sensitive)."},{"in":"query","name":"productNo","style":"pipeDelimited","schema":{"type":"array","maximum":100,"items":{"type":"string"}},"description":"Pipe separated list of product numbers."},{"in":"query","name":"styleNo","style":"pipeDelimited","schema":{"type":"array","maximum":100,"items":{"type":"string"}},"description":"Pipe separated list of style numbers."},{"in":"query","name":"serieNo","schema":{"type":"string"},"description":"Serie-number"},{"in":"query","name":"hasSerieNo","schema":{"type":"boolean"},"description":"Return products that has a serie-number"},{"in":"query","name":"needsrrppriceupdate","schema":{"type":"boolean"},"description":"Return products that have a recommended retail price and the recommended retail price does not match the products price"},{"in":"query","name":"stocktransactionlistid","schema":{"type":"integer"},"description":"Search in stocktransactionlist, this will only search on products that are a part of a stocktransactionlist with this id"},{"in":"query","name":"sort-order","schema":{"type":"integer","enum":[-1,1],"default":1},"example":1,"description":"Sorting order. If 1, products are retrieved in ascending order, if -1, in descending order."},{"in":"query","name":"sort-field","schema":{"type":"string"},"example":"id","description":"Product column to sort by. Offset pagination has no guaranteed order unless `sort-field` or `sort-order` is given (`sort-field` then defaults to `id`). Special values `instock_title`, `stockno`, `bikedeskpossales` and `costprice` are also supported. Cursor pagination only supports `id`."},{"in":"query","name":"suppliername","deprecated":true,"schema":{"type":"string"},"description":"Name of the supplier. Has no effect."},{"in":"query","name":"tag","schema":{"type":"string"},"description":"Only retrieve products with this tag ID. Takes precedence over `tags`."},{"in":"query","name":"tags","style":"pipeDelimited","description":"List of tag IDs to restrict the search to (any of them). Send as `tags[]=1&tags[]=2`.","schema":{"type":"array","maxItems":100,"items":{"type":"string"}}},{"in":"query","name":"supplierid","schema":{"type":"string"},"description":"Only retrieve products from the supplier with this ID."},{"in":"query","name":"partnerstoreid","schema":{"type":"string"},"description":"List products for a partner store that shares product data with the current store. Responds 401 if the store does not share product data."},{"in":"query","name":"vatmode","schema":{"type":"string","enum":["normal","second_hand"]},"description":"VAT mode"},{"in":"query","name":"updated_after","schema":{"type":"string"},"description":"Get all products updated at or after the given date (`Y-m-d H:i:s`).","example":"2020-01-01 00:00:00"},{"in":"query","name":"created_before","schema":{"type":"string"},"description":"Get all products created at or before the given date (`Y-m-d H:i:s`).","example":"2020-01-01 00:00:00"},{"in":"query","name":"updated_before","schema":{"type":"string"},"description":"Get all products updated at or before the given date (`Y-m-d H:i:s`).","example":"2020-01-01 00:00:00"},{"in":"query","name":"getDiscountPrice","schema":{"type":"boolean"},"description":"Whether to include discountprice for the products","example":true},{"in":"query","name":"hasSyncproductdatawebshop","schema":{"type":"boolean"},"description":"If given, only get products that has/has not syncproductdatawebshop set","example":true}],"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/SearchProductResponse"}}}},"401":{"description":"The store specified by `partnerstoreid` does not share product data.","content":{"application/json":{"schema":{"type":"object"}}}},"422":{"description":"Cursor pagination was combined with a `sort-field` other than `id`.","content":{"application/json":{"schema":{"type":"object"}}}}}},"post":{"tags":["Products"],"summary":"Add a new product","description":"","operationId":"addProduct","requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/SetProduct"},"examples":{"Wine":{"value":{"content":{"title":"Wine","productno":"zinfaldel_123","barcode":"79530347","stockno":12,"stockmin":6,"stockmax":26}}}}}}},"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ProductResponse"}}}},"405":{"description":"Invalid input"}}}},"/products/{productId}":{"get":{"summary":"Get a product","operationId":"getProduct","tags":["Products"],"parameters":[{"in":"path","name":"productId","schema":{"type":"integer"},"required":true,"description":"The product ID"},{"in":"query","name":"includeDiscountPrice","schema":{"type":"integer"},"required":false,"description":"Includes discountprice of a product. If set to 1, the discountprice is included, otherwise it is not included."}],"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ProductResponse"}}}},"4XX":{"description":"Not found"}}},"patch":{"tags":["Products"],"summary":"Update selected fields for a product","description":"Updates only the fields given in `content`; fields that are omitted keep their current value. The product is merged with the given fields and then saved with the same validation as `PUT`, so the result must be a valid product (for example a unique `productno` and a non-empty `title`). `content.tags` and `content.suppliers`, when given, replace the existing lists. Changing `stockno` creates a stock transaction.","operationId":"patchProduct","parameters":[{"in":"path","name":"productId","schema":{"type":"integer"},"required":true,"description":"The product ID"}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/SetProduct"},"examples":{"WineChangeTitle":{"description":"Change only the title of a product","value":{"content":{"title":"Wine"}}},"WineOverwriteStockNumber":{"description":"Overwrite the stock number of a product","value":{"content":{"stockno":18},"stocktransactionreason":"Stock count"}}}}}},"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ProductResponse"}}}},"400":{"description":"The resulting product is invalid, for example the product number or barcode is already in use, the title is empty or the cost price is negative. See `errorcode` in the body (for example `PRODUCT_PRODUCTNO_EXISTS`, `PRODUCT_BARCODE_EXISTS`, `PRODUCT_TITLE_INVALID`, `PRODUCT_TAG_NOT_FOUND`).","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse"}}}},"404":{"description":"The product does not exist or is not accessible to the store.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse"}}}},"422":{"description":"A referenced supplier (`content.suppliers[].id`) or VAT type (`content.vat_type_id`) does not exist.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse"}}}}}},"put":{"tags":["Products"],"summary":"Replace a product","description":"","operationId":"replaceProduct","parameters":[{"in":"path","name":"productId","schema":{"type":"integer"},"required":true,"description":"The product ID"}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/SetProduct"},"examples":{"WineAbsoluteOverwriteStockNumber":{"description":"Overwrite stock number of wine","value":{"content":{"title":"Wine","productno":"zinfaldel_123","barcode":"79530347","stockno":18,"stockmin":6,"stockmax":26}}}}}}},"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ProductResponse"}}}},"4XX":{"description":"Bad request"}}},"delete":{"summary":"Delete a product","operationId":"deleteProduct","tags":["Products"],"parameters":[{"in":"path","name":"productId","schema":{"type":"integer"},"required":true,"description":"The product ID"}],"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ProductResponse"}}}},"4XX":{"description":"Not found"}}}},"/producttags":{"get":{"tags":["ProductTags"],"summary":"Get list of product tags used by the store","operationId":"getProductTags","parameters":[{"in":"query","name":"handles","style":"pipeDelimited","schema":{"type":"array","maximum":100,"items":{"type":"string"}},"description":"Pipe separated list of tag handles."},{"in":"query","name":"ids","style":"pipeDelimited","schema":{"type":"array","maximum":100,"items":{"type":"string"}},"description":"Pipe separated list of ids handles."}],"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ProductTagListResponse"}}}}}},"post":{"tags":["ProductTags"],"summary":"Create a new product tag","operationId":"createProductTag","requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ProductTag"}}}},"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ProductTagResponse"}}}}}}},"/producttags/{id}":{"get":{"parameters":[{"$ref":"#/components/parameters/id"}],"tags":["ProductTags"],"summary":"Get a product tag used by the store","operationId":"getProductTag","responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ProductTagResponse"}}}}}},"delete":{"parameters":[{"$ref":"#/components/parameters/id"}],"tags":["ProductTags"],"summary":"Delete a product tag","operationId":"deleteProductTag","responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ProductTagResponse"}}}}}},"put":{"parameters":[{"$ref":"#/components/parameters/id"}],"tags":["ProductTags"],"summary":"Update a product tag","operationId":"updateProductTag","requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ProductTag"}}}},"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ProductTagResponse"}}}}}}},"/promotions":{"get":{"tags":["Promotions"],"summary":"List promotions for store.","parameters":[{"$ref":"#/components/parameters/cursor"},{"in":"query","name":"paginationStart","schema":{"type":"integer","default":0},"example":100,"description":"Determine the offset (in number of items) to fetch. This is usually a multiple of the pageLength."},{"in":"query","name":"paginationPageLength","schema":{"type":"integer","default":50},"example":30,"description":"Determine the number of item to fetch in one page."},{"in":"query","name":"allowDeleted","required":false,"description":"Optional. If equal to `1`, deleted promotions will be included in the response.\n","schema":{"type":"integer","default":0}},{"in":"query","name":"freeText","required":false,"description":"Optional. Search for promotion name, product, brand, tag and customer group","schema":{"type":"string"}},{"in":"query","name":"actionType","description":"Optional. Search promotions by its action type","schema":{"type":"string","enum":["percentage","adjustPriceBy","percentageByCostprice","totalPriceUnit"]}},{"in":"query","name":"startDate","required":false,"description":"Optional. Search promotions by start date (format YYYY-MM-DD HH:MM:SS)","schema":{"type":"string"}},{"in":"query","name":"endDate","required":false,"description":"Optional. Search promotions by end date (format YYYY-MM-DD HH:MM:SS)","schema":{"type":"string"}},{"in":"query","name":"hideDiscountProductno","required":false,"schema":{"type":"boolean"},"description":"Optional. Filter out single product discounts"},{"in":"query","name":"hideChainPromotions","required":false,"schema":{"type":"boolean"},"description":"Optional. Filter out chain promotions"}],"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/SearchPromotionResponse"}}}}}},"post":{"tags":["Promotions"],"summary":"Add new promotion","description":"**NB:** If you want to add discount price to a specific product use discountprice on [Product](https://api-docs.c1st.com/#tag/Products/operation/replaceProduct) instead.\n\nCreate a new promotion that results in an automatic discount when matching products are put in the POS cart.\n\nThe automatic assignment of discounts is based product filters (explained in more detail below).\nWhen these filters match, the promotion triggers an action resulting in some kind of discount presentend in the cart.\nCurrently, actions come in two flavors: *single product discounts* and *bundle discounts*.\nHow the promotion will trigger depends on this flavor.\n\nSingle product discounts (`percentage`, `adjustPriceBy`, `percentageByCostprice`, `totalPriceUnit`):\n  Here, a single product gets discount by some amount.\n  The filters can match against productnos, brands and tags.\n\nEach promotion has a required `name` which shown in the cart when the discount is given.\n`description` is optional and designed only for humans to read. It is only shown in the settings.\n`active` can be used to disable promotions until they are ready.\nPromotions will also only be considered active when today's date is inside the `startdate`-`enddate`-range.\nIf `enddate` is `null`, the promotion is considered to run forever.\n\nProduct filters are inclusive by nature. In the future, excluding filters will be added as well.\nFilters have an `attribute` and a `value`. The attribute can be various attributes of a product, like `tag` and `productno`.\nFor instance, to give a discount on all bikes with tag *Bike*, see the example below).\nThe `value` can be a list of values in which case, if either of the values match, the filter matches.\nAnd if either of the filters matches, the promotion will trigger (in case of single product discounts).\n\nThe filters for bundle discounts currently needs to be very specific:\nA single filter with `attribute` = productno and `value` = *list of productnos*.\n\nIn the future, it will be possible to filter based on customer attributes as well, such that specific customers can get certain discounts.\n","requestBody":{"required":true,"content":{"application/json":{"schema":{"type":"object","properties":{"content":{"$ref":"#/components/schemas/Promotion"}},"additionalProperties":false}}}},"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"type":"object","properties":{"id":{"type":"integer","example":123,"description":"The id of the promotion."}},"additionalProperties":false}}}}}}},"/promotions/{id}":{"get":{"operationId":"retrieve","tags":["Promotions"],"summary":"Retrieve promotion","description":"Given a specific promotion id, fetch the entire promotion object.","parameters":[{"in":"path","name":"id","required":true,"schema":{"type":"integer"}}],"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Promotion"}}}},"4XX":{"description":"Ok"}}},"put":{"operationId":"update","tags":["Promotions"],"summary":"Update promotion","description":"Replace the promotion object of a specific promotion with another.","requestBody":{"required":true,"content":{"application/json":{"schema":{"type":"object","properties":{"content":{"$ref":"#/components/schemas/Promotion"}},"additionalProperties":false}}}},"parameters":[{"in":"path","name":"id","required":true,"schema":{"type":"integer"}}],"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"type":"object","properties":{"updated":{"type":"integer","example":1,"description":"Whether or not the promotion was deleted. 0 for failure, 1 for success."}},"additionalProperties":false}}}}}},"delete":{"operationId":"delete","tags":["Promotions"],"summary":"Delete promotion.","description":"Delete a promotion based an id.","parameters":[{"in":"path","name":"id","required":true,"schema":{"type":"integer"}}],"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"type":"object","properties":{"deleted":{"type":"integer","example":1,"description":"Whether or not the promotion was deleted. 0 for failure, 1 for success."}},"additionalProperties":false}}}}}}},"/promotions/lookup":{"post":{"tags":["Promotions"],"summary":"Get all relevant promotions for a set of products and a customer.","description":"Get all relevant promotions for a set of products and a customer.\nCurrently the customer is ignore and can be null.\nThis query can be seen as \"given a cart, what promotions will match?\"\n\nIf you have multiple of the same products in the query, they should be represented as a `CartArticle`,\ni.e. specified by a `productno` and `quantity` (see example). Otherwise, you can simply use productno strings.\n","requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/PromotionLookup"}}}},"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PromotionLookupResponse"}}}}}}},"/recurringpayment/{id}":{"get":{"parameters":[{"$ref":"#/components/parameters/id"}],"tags":["RecurringPayment - Experimental"],"summary":"Get a recurring payment by id","responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/RecurringPaymentResponse"}}}},"4XX":{"description":"Bad request"}}}},"/recurringpayment":{"get":{"tags":["RecurringPayment - Experimental"],"summary":"Get a list of recurring payments","parameters":[{"in":"query","name":"paginationStart","schema":{"type":"integer","default":0},"example":100},{"in":"query","name":"paginationPageLength","schema":{"type":"integer","default":20,"maximum":200},"example":20},{"in":"query","name":"exceededduedate","schema":{"type":"integer","description":"If exceededduedate is 1, it wil get all recurring payments, where the nextduedate is exceeded, and the customer still needs to pay."}}],"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/SearchRecurringPaymentResponse"}}}},"4XX":{"description":"Bad request"}}},"post":{"tags":["RecurringPayment - Experimental"],"summary":"Creates a recurring payment","requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/RecurringPaymentRequest"}}}},"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/RecurringPaymentResponse"}}}},"4XX":{"description":"Bad request"}}}},"/recurringpayment/{id}/term/invoice":{"post":{"parameters":[{"$ref":"#/components/parameters/id"}],"tags":["RecurringPayment - Experimental"],"summary":"Creates a new term payment and issues an invoice to economic. It degrades costprice and subtracts from amountleft.","responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/POSPaymentResponse"}}}},"4XX":{"description":"Bad request"}}}},"/recurringpayment/{id}/cancel":{"post":{"parameters":[{"$ref":"#/components/parameters/id"}],"tags":["RecurringPayment - Experimental"],"summary":"Cancels given recurring payment and regulates stock for the product and costprice","responses":{"204":{"description":"Ok"},"4XX":{"description":"Bad request"}}}},"/pospayments/{paymentId}/recurringpayment":{"post":{"parameters":[{"$ref":"#/components/parameters/paymentId"}],"tags":["RecurringPayment - Experimental"],"summary":"Creates a recurring payment in draft mode and attaches an article to the given payment, which is -amountleft","requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/RecurringPaymentRequest"}}}},"responses":{"200":{"description":"Ok","content":{"application/json":{"schema":{"$ref":"#/components/schemas/RecurringPaymentResponse"}}}},"4XX":{"description":"Bad request"}}}},"/recurringpayment/{id}/returnproduct":{"post":{"parameters":[{"$ref":"#/components/parameters/id"}],"tags":["RecurringPayment - Experimental"],"summary":"Return products that are in the recurring payment, regulates stock for the product and costprice","responses":{"204":{"description":"Ok"},"4XX":{"description":"Bad request"}}}},"/sales-order-fulfillments/{salesOrderFulfillmentId}/sales-order-fulfillment-materials":{"get":{"tags":["SalesOrderFulfillmentMaterials"],"summary":"List salesorderfulfillment materials","parameters":[{"name":"salesOrderFulfillmentId","in":"path","description":"Sales order ID","required":true,"schema":{"type":"integer"}},{"name":"search","in":"query","description":"Search string","required":false,"schema":{"type":"string"}},{"name":"page","in":"query","description":"Page number","required":false,"schema":{"type":"integer"}},{"name":"pageSize","in":"query","description":"Page size","required":false,"schema":{"type":"integer"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/SalesOrderFulfillmentMaterialSearchResponse"}}}}}},"post":{"tags":["SalesOrderFulfillmentMaterials"],"summary":"Create salesorderfulfillment material","parameters":[{"name":"salesOrderFulfillmentId","in":"path","description":"Sales order ID","required":true,"schema":{"type":"integer"}}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/SalesOrderFulfillmentMaterialCreateRequest"}}}},"responses":{"200":{"description":"Created","content":{"application/json":{"schema":{"$ref":"#/components/schemas/SalesOrderFulfillmentMaterial"}}}}}}},"/sales-order-fulfillment-materials/{id}":{"get":{"tags":["SalesOrderFulfillmentMaterials"],"summary":"Get salesorderfulfillment material","parameters":[{"name":"id","in":"path","description":"Order ID","required":true,"schema":{"type":"integer"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/SalesOrderFulfillmentMaterialResponse"}}}}}},"put":{"tags":["SalesOrderFulfillmentMaterials"],"summary":"Update salesorderfulfillment material","parameters":[{"name":"id","in":"path","description":"Order ID","required":true,"schema":{"type":"integer"}}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/SalesOrderFulfillmentMaterial"}}}},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/SalesOrderFulfillmentMaterialResponse"}}}}}}},"/sales-order-fulfillments":{"get":{"tags":["SalesOrderFullfillments"],"summary":"List salesorder fulfillments","parameters":[{"name":"freetext","in":"query","description":"Search string","required":false,"schema":{"type":"string"}},{"name":"storeid","in":"query","description":"Filter by the id of the fulfilling store","required":false,"schema":{"type":"integer"}},{"name":"salesOrderStoreid","in":"query","description":"Filter by the id of store that created the order","required":false,"schema":{"type":"integer"}},{"name":"salesOrderid","in":"query","description":"Filter by the id of the salesorder","required":false,"schema":{"type":"integer"}},{"name":"page","in":"query","description":"Page number","required":false,"schema":{"type":"integer"}},{"name":"pageSize","in":"query","description":"Page size","required":false,"schema":{"type":"integer"}},{"name":"includeDrafts","in":"query","description":"Include draft orders","required":false,"schema":{"type":"boolean"}},{"name":"open","in":"query","description":"Filter by open/closed status","required":false,"schema":{"type":"boolean"}},{"name":"status","in":"query","description":"Filter by status. Can be comma separated list of statuses","required":false,"schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/SalesOrderFulfillmentSearchResponse"}}}}}},"post":{"tags":["SalesOrderFullfillments"],"summary":"Create salesorder fulfillment","requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/SalesOrderFulfillmentCreateRequest"}}}},"responses":{"200":{"description":"Created","content":{"application/json":{"schema":{"$ref":"#/components/schemas/SalesOrderFulfillment"}}}}}}},"/sales-order-fulfillments/{id}":{"get":{"tags":["SalesOrderFullfillments"],"summary":"Get salesorder fulfillment","parameters":[{"name":"id","in":"path","description":"Order ID","required":true,"schema":{"type":"integer"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/SalesOrderFulfillmentResponse"}}}}}},"put":{"tags":["S
[...]
